<template>
  <q-item
    class="max-w"
    dense
    v-for="funcion in funcionesUnicas"
    :key="funcion.funcion"
  >
    <q-item-section>
      <q-item-label v-if="checkGrupo(funcion.organismo_full)">
        {{ funcion.organismo_full }}
      </q-item-label>
      <q-item-label caption v-if="!funcion.beneficiario">
        {{ funcion.funcion }}
        <q-chip
          v-if="funcion.origen == 'M'"
          color="orange"
          text-color="white"
          size="xs"
          title="Esta funcion fue generada de forma manual en Mi Rincon"
        >
          M
        </q-chip>
      </q-item-label>
      <q-item-label caption v-if="funcion.beneficiario">
        Beneficiario
      </q-item-label>
    </q-item-section>

    <q-item-section side>
      <div v-if="!funcion.beneficiario">{{ funcion.categoria }}</div>
      <q-chip
        v-if="funcion.beneficiario"
        square
        :color="funcion.rama.color"
        text-color="white"
        size="sm"
      >
        {{ funcion.rama.rama }}
      </q-chip>
    </q-item-section>
  </q-item>
</template>

<script lang="ts">
import { defineComponent, ref } from 'vue';

export default defineComponent({
  name: 'PersonasFunciones',
  components: {},
  props: {
    funciones: {
      type: [Array, Object],
      required: true,
    },
  },

  computed: {
    funcionesUnicas() {
      const unique = this.funciones.filter((obj, index: number) => {
        return (
          index ===
          this.funciones.findIndex(
            (o) =>
              obj.organismo_codigo === o.organismo_codigo &&
              obj.funcion === o.funcion &&
              obj.origen === o.origen
          )
        );
      });
      return unique;
    },
  },

  setup() {
    const grupo = ref();

    function checkGrupo(valor: string) {
      return true;
      const temp = grupo.value;
      grupo.value = valor;
      return temp !== grupo.value;
    }

    return {
      checkGrupo,
    };
  },
});
</script>
